
/*  -*- MaTX -*-
 *
 *  ̾
 *      expm1() - ѥǶˤؿ
 *
 *  ڷ
 *      e = expm1(a)
 *         Matrix e;
 *         Matrix a;
 *
 *  ڻʸ
 *      [1] Golub & Van Loan, Matrix Computations, Algorithm 11.3-1.
 * 
 */

Func Matrix expm1(aa)
	Matrix aa;
{
	Matrix a,e,X,d,cX;
	Integer n,p,q,qp1,q2p1,k;
	Real c,s;

	a = aa;

	// Υब 1/2 ʲˤʤ褦 A  2 ߾ǥ󥰤
	s = infnorm(a);
	if (s > 0) {
		s = max(0.0, fix(log(s)/log(2.0)) + 2.0);
	}
	a = a/(2^Integer(s));

	// exp(A)ΥѥǶ
	X = a; 
	{n,n} = size(a);
	c = 1.0/2.0;
	e = I(n) + c*a;
	d = I(n) - c*a;
	q = 6;
	p = 1;
	qp1 = q + 1;
	q2p1 = 2*q + 1;

	for (k = 2; k <= q; k++) {
		c = c * Real(qp1 - k) / Real(k*(q2p1-k));
		X = a*X;
		cX = c*X;
		e = e + cX;
		if (p) {
			d = d + cX;
		} else {
			d = d - cX;
		}
		p = ( ! p );
	}
	e = d\e;

	// 2 򷫤֤ơ󥰤᤹
	for (k = 1; k <= Integer(s); k++) {
		e = e*e;
	}

	return e;
}
